'use strict';

exports.__esModule = true;
exports.run = run;
exports.done = done;
exports.startCheck = startCheck;
exports.startCheckAndRun = startCheckAndRun;

var _util = require('./util');

function run() {
    if (this.tasks.list.length) {
        if (this.tasks.running < this.concurrency) {
            this.tasks.list.shift()(done.bind(this));
            this.tasks.running++;
        }
    } else {
        if (this.tasks.completed === this.tasks.total) {
            this.duration.end = Date.now();
            this.duration.total = this.duration.end - this.duration.start;
            if ((0, _util.isFunction)(this.onEnd)) {
                var completed = this.tasks.completed,
                    duration = this.duration;

                this.onEnd({ completed: completed, duration: duration });
            }
        }
    }
}

function done() {
    this.tasks.completed++;
    this.tasks.running--;
    this.duration.total = Date.now() - this.duration.start;
    if ((0, _util.isFunction)(this.onDone)) {
        this.onDone(this.tasks);
    }
    run.call(this);
}

function startCheck() {
    if (!this.__working) {
        this.duration.start = Date.now();
        this.__working = true;
        if ((0, _util.isFunction)(this.on)) {
            this.onStart();
        }
    }
}

function startCheckAndRun() {
    startCheck.call(this);
    run.call(this);
}